PIndirectChannel Class Reference

This is a channel that operates indirectly through another channel(s). More...

`#include <indchan.h>`

Inheritance diagram for PIndirectChannel:

## Public Member Functions

Construction
| PIndirectChannel ()
| Create a new indirect channel without any channels to redirect to. More...
| ~PIndirectChannel ()
| Close the indirect channel, deleting read/write channels if desired. More...
Overrides from class PObject
Comparison | Compare (const PObject &obj) const
| Determine if the two objects refer to the same indirect channel. More...
Overrides from class PChannel
virtual PString | GetName () const
| Get the name of the channel. More...
virtual PBoolean | Close ()
| Close the channel. More...
virtual PBoolean | IsOpen () const
| Determine if the channel is currently open and read and write operations can be executed on it. More...
virtual PBoolean | Read (void *buf, PINDEX len)
| Low level read from the channel. More...
virtual PBoolean | Write (const void *buf, PINDEX len)
| Low level write to the channel. More...
virtual PBoolean | Shutdown (ShutdownValue option)
| Close one or both of the data streams associated with a channel. More...
virtual bool | SetLocalEcho (bool localEcho)
| Set local echo mode. More...
virtual PChannel * | GetBaseReadChannel () const
| This function returns the eventual base channel for reading of a series of indirect channels provided by descendents of `PIndirectChannel`. More...
virtual PChannel * | GetBaseWriteChannel () const
| This function returns the eventual base channel for writing of a series of indirect channels provided by descendents of `PIndirectChannel`. More...
virtual PString | GetErrorText (ErrorGroup group=NumErrorGroups) const
| Get error message description. More...
Channel establish functions
PBoolean | Open (PChannel &channel)
| Set the channel for both read and write operations. More...
PBoolean | Open (PChannel *channel, PBoolean autoDelete=true)
| Set the channel for both read and write operations. More...
PBoolean | Open (PChannel *readChannel, PChannel *writeChannel, PBoolean autoDeleteRead=true, PBoolean autoDeleteWrite=true)
| Set the channel for both read and write operations. More...
PChannel * | GetReadChannel () const
| Get the channel used for read operations. More...
bool | SetReadChannel (PChannel *channel, bool autoDelete=true, bool closeExisting=false)
| Set the channel for read operations. More...
PChannel * | GetWriteChannel () const
| Get the channel used for write operations. More...
PBoolean | SetWriteChannel (PChannel *channel, bool autoDelete=true, bool closeExisting=false)
| Set the channel for read operations. More...
Public Member Functions inherited from PChannel
PBoolean | SetErrorValues (Errors errorCode, int osError, ErrorGroup group=LastGeneralError)
| Set error values to those specified. More...
| PChannel ()
| Create the channel. More...
| ~PChannel ()
| Close down the channel. More...
virtual PINDEX | HashFunction () const
| Calculate a hash value for use in sets and dictionaries. More...
int | GetHandle () const
| Get the integer operating system handle for the channel. More...
void | SetReadTimeout (const PTimeInterval &time)
| Set the timeout for read operations. More...
PTimeInterval | GetReadTimeout () const
| Get the timeout for read operations. More...
virtual PINDEX | GetLastReadCount () const
| Get the number of bytes read by the last Read() call. More...
virtual int | ReadChar ()
| Read a single 8 bit byte from the channel. More...
PBoolean | ReadBlock (void *buf, PINDEX len)
| Read len bytes into the buffer from the channel. More...
PString | ReadString (PINDEX len)
| Read `len` character into a string from the channel. More...
virtual PBoolean | ReadAsync (void *buf, PINDEX len)
| Begin an asynchronous read from channel. More...
virtual void | OnReadComplete (void *buf, PINDEX len)
| User callback function for when a `ReadAsync()` call has completed or timed out. More...
void | SetWriteTimeout (const PTimeInterval &time)
| Set the timeout for write operations to complete. More...
PTimeInterval | GetWriteTimeout () const
| Get the timeout for write operations to complete. More...
virtual PBoolean | Write (const void *buf, PINDEX len, const void *mark)
| Low level write to the channel with marker. More...
virtual PINDEX | GetLastWriteCount () const
| Get the number of bytes written by the last Write() call. More...
PBoolean | WriteChar (int c)
| Write a single character to the channel. More...
PBoolean | WriteString (const PString &str)
| Write a string to the channel. More...
virtual PBoolean | WriteAsync (const void *buf, PINDEX len)
| Begin an asynchronous write from channel. More...
virtual void | OnWriteComplete (const void *buf, PINDEX len)
| User callback function for when a WriteAsync() call has completed or timed out. More...
virtual bool | FlowControl (const void *flowData)
| Flow Control information Pass data to the channel for flowControl determination. More...
PBoolean | SetBufferSize (PINDEX newSize)
| Set the iostream buffer size for reads and writes. More...
PBoolean | SendCommandString (const PString &command)
| Send a command meta-string. More...
void | AbortCommandString ()
| Abort a command string that is in progress. More...
Errors | GetErrorCode (ErrorGroup group=NumErrorGroups) const
| Get normalised error code. More...
int | GetErrorNumber (ErrorGroup group=NumErrorGroups) const
| Get OS errro code. More...
virtual PBoolean | Read (const VectorOfSlice &slices)
| Low level scattered read from the channel. More...
virtual PBoolean | Write (const VectorOfSlice &slices)
| Low level scattered write to the channel. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions

virtual PBoolean | OnOpen ()
| This callback is executed when the Open() function is called with open channels. More...
Protected Member Functions inherited from PChannel
| PChannel (const PChannel &)
PChannel & | operator= (const PChannel &)
virtual PBoolean | ConvertOSError (int libcReturnValue, ErrorGroup group=LastGeneralError)
| Convert an operating system error into platform independent error. More...
int | ReadCharWithTimeout (PTimeInterval &timeout)
| Read a character with specified timeout. More...
PBoolean | ReceiveCommandString (int nextChar, const PString &reply, PINDEX &pos, PINDEX start)
PBoolean | PXSetIOBlock (PXBlockType type, const PTimeInterval &timeout)
int | PXClose ()
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes

PChannel * | readChannel
| Channel for read operations. More...
PBoolean | readAutoDelete
| Automatically delete read channel on destruction. More...
PChannel * | writeChannel
| Channel for write operations. More...
PBoolean | writeAutoDelete
| Automatically delete write channel on destruction. More...
PReadWriteMutex | channelPointerMutex
| Race condition prevention on closing channel. More...
Protected Attributes inherited from PChannel
int | os_handle
| The operating system file handle return by standard open() function. More...
Errors | lastErrorCode [NumErrorGroups+1]
| The platform independant error code. More...
int | lastErrorNumber [NumErrorGroups+1]
| The operating system error number (eg as returned by errno). More...
PINDEX | lastReadCount
| Number of byte last read by the Read() function. More...
PINDEX | lastWriteCount
| Number of byte last written by the Write() function. More...
PTimeInterval | readTimeout
| Timeout for read operations. More...
PTimeInterval | writeTimeout
| Timeout for write operations. More...
PString | channelName
PMutex | px_threadMutex
PXBlockType | px_lastBlockType
PThread * | px_readThread
PThread * | px_writeThread
PMutex | px_writeMutex
PThread * | px_selectThread [3]
PMutex | px_selectMutex [3]

## Additional Inherited Members

Public Types inherited from PChannel
enum | PXBlockType { PXReadBlock, PXWriteBlock, PXAcceptBlock, PXConnectBlock }
enum | ShutdownValue { ShutdownRead = 0, ShutdownWrite = 1, ShutdownReadAndWrite = 2 }
enum | Errors { NoError, NotFound, FileExists, DiskFull, AccessDenied, DeviceInUse, BadParameter, NoMemory, NotOpen, Timeout, Interrupted, BufferTooSmall, Miscellaneous, ProtocolFailure, NumNormalisedErrors }
| Normalised error codes. More...
enum | ErrorGroup { LastReadError, LastWriteError, LastGeneralError, NumErrorGroups }
| Error groups. More...
typedef std::vector< Slice > | VectorOfSlice
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PChannel
static PBoolean | ConvertOSError (int libcReturnValue, Errors &lastError, int &osError)
| Convert an operating system error into platform independent error. More...
static PString | GetErrorText (Errors lastError, int osError=0)
| Get error message description. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...

## Detailed Description

This is a channel that operates indirectly through another channel(s).

This allows for a protocol to operate through a "channel" mechanism and for its low level byte exchange (Read and Write) to operate via a completely different channel, eg TCP or Serial port etc.

## Constructor & Destructor Documentation

PIndirectChannel::PIndirectChannel | ( |  | ) |

Create a new indirect channel without any channels to redirect to.

If an attempt to read or write is made before Open() is called the the functions will assert.

PIndirectChannel::~PIndirectChannel | ( |  | ) |

Close the indirect channel, deleting read/write channels if desired.

## Member Function Documentation

virtual PBoolean PIndirectChannel::Close | ( |  | ) |

virtual

Close the channel.

This will detach itself from the read and write channels and delete both of them if they are auto delete.

Returns
  true if the channel is closed.

Reimplemented from PChannel.

Reimplemented in PRFC822Channel, PPOP3Client, PVXMLChannel, PSSLChannel, PVXMLSession, XMPP::Stream, XMPP::Transport, PSMTPClient, PFTPClient, and XMPP::C2S::TCPTransport.

Comparison PIndirectChannel::Compare | ( | const PObject & | obj | ) | const

virtual

Determine if the two objects refer to the same indirect channel.

This actually compares the channel pointers.

Returns
  EqualTo if channel pointer identical.

Parameters

  obj | Another indirect channel to compare against.

Reimplemented from PChannel.

virtual PChannel* PIndirectChannel::GetBaseReadChannel | ( |  | ) | const

virtual

This function returns the eventual base channel for reading of a series of indirect channels provided by descendents of `PIndirectChannel`.

The behaviour for this function is to return "this".

Returns
  Pointer to base I/O channel for the indirect channel.

Reimplemented from PChannel.

virtual PChannel* PIndirectChannel::GetBaseWriteChannel | ( |  | ) | const

virtual

This function returns the eventual base channel for writing of a series of indirect channels provided by descendents of `PIndirectChannel`.

The behaviour for this function is to return "this".

Returns
  Pointer to base I/O channel for the indirect channel.

Reimplemented from PChannel.

virtual PString PIndirectChannel::GetErrorText | ( | ErrorGroup | group = `NumErrorGroups` | ) | const

virtual

Get error message description.

Return a string indicating the error message that may be displayed to the user. The error for the last I/O operation in this object is used.

Returns
  Operating System error description string.

Parameters

  group | Error group to get

Reimplemented from PChannel.

Reimplemented in PSSLChannel.

virtual PString PIndirectChannel::GetName | ( |  | ) | const

virtual

Get the name of the channel.

This is a combination of the channel pointers names (or simply the channel pointers name if the read and write channels are the same) or empty string if both null.

Returns
  string for the channel names.

Reimplemented from PChannel.

PChannel* PIndirectChannel::GetReadChannel | ( |  | ) | const

Get the channel used for read operations.

Returns
  pointer to the read channel.

PChannel* PIndirectChannel::GetWriteChannel | ( |  | ) | const

Get the channel used for write operations.

Returns
  pointer to the write channel.

virtual PBoolean PIndirectChannel::IsOpen | ( |  | ) | const

virtual

Determine if the channel is currently open and read and write operations can be executed on it.

For example, in the `PFile` class it returns if the file is currently open.

Returns
  true if the channel is open.

Reimplemented from PChannel.

Reimplemented in PVXMLChannel.

virtual PBoolean PIndirectChannel::OnOpen | ( |  | ) |

protected virtual

This callback is executed when the Open() function is called with open channels.

It may be used by descendent channels to do any handshaking required by the protocol that channel embodies.

The default behaviour is to simply return true.

Returns
  Returns true if the protocol handshaking is successful.

Reimplemented in PRFC822Channel, PPOP3Server, PPOP3Client, PSSLChannel, PFTPServer, PSMTPServer, PFTPClient, PSMTPClient, and XMPP::Stream.

PBoolean PIndirectChannel::Open | ( | PChannel & | channel | ) |

Set the channel for both read and write operations.

This then checks that they are open and then calls the OnOpen() virtual function. If it in turn returns true then the Open() function returns success.

Returns
  true if both channels are set, open and OnOpen() returns true.

Parameters

  channel | Channel to be used for both read and write operations.

PBoolean PIndirectChannel::Open | ( | PChannel * | channel,
|  | PBoolean | autoDelete = `true`
| ) |  |

Set the channel for both read and write operations.

This then checks that they are open and then calls the OnOpen() virtual function. If it in turn returns true then the Open() function returns success.

The channel pointed to by `channel` may be automatically deleted when the PIndirectChannel is destroyed or a new subchannel opened.

Returns
  true if both channels are set, open and OnOpen() returns true.

Parameters

  channel | Channel to be used for both read and write operations.
  autoDelete | Automatically delete the channel

PBoolean PIndirectChannel::Open | ( | PChannel * | readChannel,
|  | PChannel * | writeChannel,
|  | PBoolean | autoDeleteRead = `true`,
|  | PBoolean | autoDeleteWrite = `true`
| ) |  |

Set the channel for both read and write operations.

This then checks that they are open and then calls the OnOpen() virtual function. If it in turn returns true then the Open() function returns success.

The channels pointed to by `readChannel` and `writeChannel` may be automatically deleted when the PIndirectChannel is destroyed or a new subchannel opened.

Returns
  true if both channels are set, open and OnOpen() returns true.

Parameters

  readChannel | Channel to be used for both read operations.
  writeChannel | Channel to be used for both write operations.
  autoDeleteRead | Automatically delete the read channel
  autoDeleteWrite | Automatically delete the write channel

virtual PBoolean PIndirectChannel::Read | ( | void * | buf,
|  | PINDEX | len
| ) |  |

virtual

Low level read from the channel.

This function may block until the requested number of characters were read or the read timeout was reached. The GetLastReadCount() function returns the actual number of bytes read.

This will use the `readChannel` pointer to actually do the read. If `readChannel` is null the this asserts.

The GetErrorCode() function should be consulted after Read() returns false to determine what caused the failure.

Returns
  true indicates that at least one character was read from the channel. false means no bytes were read due to timeout or some other I/O error.

Parameters

  buf | Pointer to a block of memory to receive the read bytes.
  len | Maximum number of bytes to read into the buffer.

Reimplemented from PChannel.

Reimplemented in PVXMLChannel, PSSLChannel, PDelayChannel, and PInternetProtocol.

virtual bool PIndirectChannel::SetLocalEcho | ( | bool | localEcho | ) |

virtual

Set local echo mode.

For some classes of channel, e.g. PConsoleChannel, data read by this channel is automatically echoed. This disables the function so things like password entry can work.

Default behaviour does nothing and return true if the channel is open.

Reimplemented from PChannel.

bool PIndirectChannel::SetReadChannel | ( | PChannel * | channel,
|  | bool | autoDelete = `true`,
|  | bool | closeExisting = `false`
| ) |  |

Set the channel for read operations.

Returns
  Returns true if both channels are set and are both open.

Parameters

  channel | Channel to be used for both read operations.
  autoDelete | Automatically delete the channel
  closeExisting | Close (and auto-delete) the existing read channel

PBoolean PIndirectChannel::SetWriteChannel | ( | PChannel * | channel,
|  | bool | autoDelete = `true`,
|  | bool | closeExisting = `false`
| ) |  |

Set the channel for read operations.

Returns
  Returns true if both channels are set and are both open.

Parameters

  channel | Channel to be used for both read operations.
  autoDelete | Automatically delete the channel
  closeExisting | Close (and auto-delete) the existing read channel

virtual PBoolean PIndirectChannel::Shutdown | ( | ShutdownValue | option | ) |

virtual

Close one or both of the data streams associated with a channel.

The behavour here is to pass the shutdown on to its read and write channels.

Returns
  true if the shutdown was successfully performed.

Parameters

  option | Flag for shut down of read, write or both.

Reimplemented from PChannel.

Reimplemented in PSSLChannel.

virtual PBoolean PIndirectChannel::Write | ( | const void * | buf,
|  | PINDEX | len
| ) |  |

virtual

Low level write to the channel.

This function will block until the requested number of characters are written or the write timeout is reached. The GetLastWriteCount() function returns the actual number of bytes written.

This will use the `writeChannel` pointer to actually do the write. If `writeChannel` is null the this asserts.

The GetErrorCode() function should be consulted after Write() returns false to determine what caused the failure.

Returns
  true if at least len bytes were written to the channel.

Parameters

  buf | Pointer to a block of memory to write.
  len | Number of bytes to write.

Reimplemented from PChannel.

Reimplemented in PRFC822Channel, PVXMLChannel, PSSLChannel, PDelayChannel, XMPP::Stream, PInternetProtocol, and PCLI::Context.

## Member Data Documentation

PReadWriteMutex PIndirectChannel::channelPointerMutex

protected

Race condition prevention on closing channel.

PBoolean PIndirectChannel::readAutoDelete

protected

Automatically delete read channel on destruction.

PChannel* PIndirectChannel::readChannel

protected

Channel for read operations.

Referenced by PVXMLSession::GetVXMLChannel().

PBoolean PIndirectChannel::writeAutoDelete

protected

Automatically delete write channel on destruction.

PChannel* PIndirectChannel::writeChannel

protected

Channel for write operations.

The documentation for this class was generated from the following file:

- indchan.h